#pragma semicolon 1

#include <sourcemod>
#include <sdktools>

#define NUM_HINTS							26
#define HINT_STRINGSIZE						256

#define HINT_DEFAULT_TIME					"85"

new String:g_strHints[NUM_HINTS][HINT_STRINGSIZE];
new Float:g_fLastHintTimer = 0.0;
new Handle:g_hRandomHintTimer = INVALID_HANDLE;

public Plugin:myinfo = 
{
	name = "L4D Random Hints",
	author = "Dresk",
	description = "Provides random hints to all players.",
	version = "1.0",
	url = ""
}

public PopulateHintsArray()
{
	new nCnt = 0;
	g_strHints[nCnt++] = "Always try to ration your medkit; don't use it until your next down is your last!";
	g_strHints[nCnt++] = "Burning Hunters immediately damage Survivors they pounce!  Get them off quick!";
	g_strHints[nCnt++] = "Boomer bile causes the spawned Infected to ignore all others and only attack the victim!";
	g_strHints[nCnt++] = "You cannot damage teammates who are being pulled by a Smoker or pounced by a Hunter!";
	g_strHints[nCnt++] = "Smokers die from one bullet if shot while dragging someone!";
	g_strHints[nCnt++] = "During Finales, keep doors open and broken so you can close them if a Tank comes!";
	g_strHints[nCnt++] = "Bullets that pierce through walls or doors never harm teammates!";
	g_strHints[nCnt++] = "An initial hunting rifle round to a Witch's head stumbles her for 3 seconds!";
	g_strHints[nCnt++] = "Burning a Witch slows her down and sets off a 13 second kill timer!";
	g_strHints[nCnt++] = "Burning a Tank does not damage it; it sets off a 40 second kill timer!";
	g_strHints[nCnt++] = "Headshots cause no additional damage to a Tank; aim for center mass!";
	g_strHints[nCnt++] = "Flashlights mean very little to a Witch!  Sound from guns is much more critical!";
	g_strHints[nCnt++] = "Propane tanks will stumble a Tank for 3 seconds!";
	g_strHints[nCnt++] = "Bullets never fully destroy doors, but melee will!";
	g_strHints[nCnt++] = "Headshots from any weapon will kill a common Infected instantly!";
	g_strHints[nCnt++] = "You can 'recycle' gascans by tossing one into an existing fire!";
	g_strHints[nCnt++] = "Witches cannot enter closed safe rooms!  Shoot them and run back inside!";
	g_strHints[nCnt++] = "Once you remove the bar from a safe room door, a Tank can break it down!";
	g_strHints[nCnt++] = "The Hunting Rifle kills common Infected at any location; aim for center mass!";
	g_strHints[nCnt++] = "Server-Side objects such as tables can be used to force Infected to climb over them!";
	g_strHints[nCnt++] = "A Survivor is immune to friendly-fire for roughly 1 second\nafter being freed from Smokers / Hunters!";
	g_strHints[nCnt++] = "Ration pain pills before a Finale; they are critical if incapacitated!";
	g_strHints[nCnt++] = "Make use of excess Pipe Bombs!  If you see extras, toss them!";
	g_strHints[nCnt++] = "When a Horde comes, try to barricade yourself in a corner / room with others!";
	g_strHints[nCnt++] = "Tanks will move slower when they have roughly 25% health or less!";
	g_strHints[nCnt++] = "Incapacitated Survivors are high-priority targets for Hordes!";
}

public Action:DisplayHint(Handle:hTimer)
{
	new nHintID = GetRandomInt(0, NUM_HINTS - 1);
	PrintHintTextToAll("Hint : %s", g_strHints[nHintID]);
	
	// Check and Update Timer
	new Float:fCurrentRandomHintTimer = GetConVarFloat(g_hRandomHintTimer);
	if(fCurrentRandomHintTimer != g_fLastHintTimer)
	{ // New Timer
		// Close Current Timer
		KillTimer(hTimer);
		// Create New Timer
		CreateTimer(fCurrentRandomHintTimer, DisplayHint, _, TIMER_REPEAT);
	}
	// Update Last Hint Timer
	g_fLastHintTimer = fCurrentRandomHintTimer;
}

public OnPluginStart()
{
	// Populate Hints Array
	PopulateHintsArray();
	// Create and Associate CVar
	g_hRandomHintTimer = CreateConVar("dresk_RandomHints_Timer", HINT_DEFAULT_TIME, "The interval (in seconds) that random hints should be displayed.");
	// Assign Initial Last Hint Timer
	g_fLastHintTimer = GetConVarFloat(g_hRandomHintTimer);
	// Create Hint Timer
	CreateTimer(g_fLastHintTimer, DisplayHint, _, TIMER_REPEAT);
}

public OnPluginEnd()
{
}